property printInfo, printType

on new me
  set printInfo to [:]
  set printType to [:]
  return me
end

on addPrintSection me, section, thePrintType, printMembers
  setaProp(printType, section, thePrintType)
  if listp(printMembers) then
    setaProp(printInfo, section, printMembers)
  else
    set theList to []
    append(theList, printMembers)
    setaProp(printInfo, section, theList)
  end if
end

on infoExists me, section
  if voidp(getaProp(printInfo, section)) then
    return 0
  else
    return 1
  end if
end

on getPrintType me, section
  return getaProp(printType, section)
end

on printInfo me, section
  set doc to new(xtra("Printomatic_Lite"))
  if not objectp(doc) then
    exit
  end if
  setDocumentName(doc, section && "info")
  set theList to getaProp(printInfo, section)
  repeat with m in theList
    append(doc, member m)
  end repeat
  print(doc)
  set doc to 0
end
